package jp.kwebs;
import java.util.List;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.ws.rs.Consumes;
import javax.ws.rs.DefaultValue;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

import org.eclipse.microprofile.rest.client.inject.RestClient;

@ApplicationScoped
@Path("/api")
@Produces(MediaType.APPLICATION_JSON)
@Consumes(MediaType.APPLICATION_JSON)

public class BookClient {

	@Inject
	@RestClient
	BookService bookService;
	
	@GET
	public List<Book> allBooks(){
		return bookService.getAllBooks();
	}

	@GET
	@Path("/{id}")
	public Book oneBookById(@PathParam("id") Long id){
		return bookService.getBookById(id);
	}

	@GET
	@Path("/query")
	public List<Book> getBooks(
			@DefaultValue("")		@QueryParam("query") String query,
			@DefaultValue("price")	@QueryParam("sort") String sort,
			@DefaultValue("0")	  	@QueryParam("index") int index,
			@DefaultValue("3")		@QueryParam("size") int size) {

		return bookService.getBooks(query, sort, index, size);
	}
	
	@GET
	@Path("/count")
	public long getCount(@DefaultValue("") @QueryParam("query") String query){
		return bookService.getCount(query);
	}
	
	@GET
	@Path("/size")
	public long getSize(
			@DefaultValue("")	@QueryParam("query") String query,	  // 検索式
			@DefaultValue("3")	@QueryParam("size") int size     ){
		return bookService.getSize(query, size);
	}

	
	
}
